import org.jetbrains.kotlin.gradle.dsl.JvmTarget
import org.jetbrains.kotlin.gradle.dsl.KotlinVersion
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.*
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.plugin.xomrk

buildscript {
	repositories {
		mavenCentral()
		maven("https://maven.landgrafhomyak.ru/")
	}

	dependencies {
		classpath("ru.landgrafhomyak.kotlin:kotlin-mpp-gradle-build:v0.3k2.1.10")
	}
}

group = "ru.landgrafhomyak.db"
version = "0.1"

repositories {
	mavenCentral()
	maven("https://maven.landgrafhomyak.ru/")
}

xomrk {
	kotlin {
		setCompatibilityWithKotlin(KotlinVersion.KOTLIN_2_0)
		optInContracts()
		explicitApi()

		jvm {
			withJava()

			compilations.configureEach {
				compileJavaTaskProvider?.configure {
					sourceCompatibility  = "1.8"
					targetCompatibility  = "1.8"
				}
				compileTaskProvider.configure {
					compilerOptions { jvmTarget = JvmTarget.JVM_1_8 }
				}
			}
		}

		sourceSets {
			jvmMain {
				dependencies {
					compileOnly("org.jetbrains:annotations:26.0.2")
					compileOnly("com.intellij:annotations:9.0.4")
					implementation("it.unimi.dsi:fastutil:6.3")
					implementation("ru.landgrafhomyak.utility:highlevel-try-finally:0.5")
					implementation("ru.landgrafhomyak.utility:reference-counter:0.2")
				}
			}
		}
	}

	publishing {
		repositories {
			defineXomrkGiteaMavenRepo()
		}

		forceSetAllMavenArtifactsId(project.name)
	}
}