package ru.langrafhomyak.db.jdbc_resources_manager

import java.sql.Clob
import java.sql.ResultSet
import java.sql.ResultSetMetaData
import java.sql.SQLType
import java.sql.Statement

internal abstract class ResultSetWrapper(protected val _orig: ResultSet) : ResultSet by _orig {
	abstract override fun close()

	abstract override fun getStatement(): Statement?

	override fun updateObject(columnIndex: Int, x: Any?, targetSqlType: SQLType?, scaleOrLength: Int) {
		this._orig.updateObject(columnIndex, x, targetSqlType, scaleOrLength)
	}

	override fun updateObject(columnLabel: String?, x: Any?, targetSqlType: SQLType?, scaleOrLength: Int) {
		this._orig.updateObject(columnLabel, x, targetSqlType, scaleOrLength)
	}

	override fun updateObject(columnIndex: Int, x: Any?, targetSqlType: SQLType?) {
		this._orig.updateObject(columnIndex, x, targetSqlType)
	}

	override fun updateObject(columnLabel: String?, x: Any?, targetSqlType: SQLType?) {
		this._orig.updateObject(columnLabel, x, targetSqlType)
	}
}